import {
  Alert,
  Button,
  Divider,
  Form,
  Input,
  Modal,
  Steps,
  message,
} from "antd";
import { useState } from "react";

const steps = [
  {
    title: "First",
    content: "First-content",
  },
  {
    title: "Second",
    content: "Second-content",
  },
  {
    title: "Last",
    content: "Last-content",
  },
];

const contentData = [
  <Form layout="vertical">
    <Form.Item label="Format des Labels">
      <Input />
    </Form.Item>
  </Form>,
  "",
  <h1>hakki</h1>,
];

const consoleContentData = [
  {
    description: [
      <p>
        Error: An Uncaught Error at s
        (https://ant.design/demos.a6f2ae2b.async.js:1:10244) at S
        (https://ant.design/umi.996fb2f6.js:6081:13535) at u at a
        (https://ant.design/umi.996fb2f6.js:41615:61022) at b
        (https://ant.design/umi.996fb2f6.js:211:19559) at S
        (https://ant.design/umi.996fb2f6.js:6081:13535) at section at section at
        $t (https://ant.design/umi.996fb2f6.js:125:690029) at h4
        (https://ant.design/umi.996fb2f6.js:211:1412)
      </p>,
    ],
    status: "error",
  },
  {
    description: [<p>Test</p>],
    status: "success",
  },
  {
    description: [<p>Test</p>],
    status: "warning",
  },
];

export default function GroupTaskModal({ isOpen, setIsOpen }) {
  const [currentStep, setCurrentStep] = useState(0);
  const [content, setContent] = useState(contentData[currentStep]);
  const [consoleContent, setConsoleContent] = useState(
    consoleContentData[currentStep]
  );

  const updateContentData = (value) => {
    setContent(contentData[value]);
  };

  const next = () => {
    const val = currentStep + 1;
    setCurrentStep(val);
    updateContentData(val);
    setConsoleContent(consoleContentData[val]);
  };

  const prev = () => {
    const val = currentStep - 1;
    setCurrentStep(val);
    updateContentData(val);
    setConsoleContent(consoleContentData[val]);
  };

  const handleCancel = () => {
    setIsOpen(false);
  };

  return (
    <Modal
      open={isOpen}
      width={"70%"}
      onCancel={handleCancel}
      maskClosable={false}
    >
      <h1 style={{ color: "#e67e22", fontWeight: "bold" }}>
        Produktionstask 1
      </h1>
      <p>
        <span style={{ fontWeight: "bold" }}>Started at:</span> 19.01.2023 -
        11:14:30
      </p>
      <Steps
        direction="vertical"
        current={currentStep}
        items={[
          {
            title: "Bild zu Label konvertieren",
            description: currentStep === 0 ? content : null,
            onClick: (value) => console.log(value),
            status: "error",
          },
          {
            title: "Label drucken",
            description: currentStep === 1 ? content : null,
          },
          {
            title: "Waiting",
            description: currentStep === 2 ? content : null,
          },
        ]}
      />
      <div style={{ marginTop: 24 }}>
        {currentStep < steps.length - 1 && (
          <Button type="primary" onClick={() => next()}>
            Next
          </Button>
        )}
        {currentStep === steps.length - 1 && (
          <Button
            type="primary"
            onClick={() => message.success("Processing complete!")}
          >
            Done
          </Button>
        )}
        {currentStep > 0 && (
          <Button style={{ margin: "0 8px" }} onClick={() => prev()}>
            Previous
          </Button>
        )}
      </div>
      <Divider />
      <Alert
        message={<b>{consoleContent.status}</b>}
        description={consoleContent.description}
        type={consoleContent.status}
        showIcon
      />
    </Modal>
  );
}
