import {
  Button,
  Divider,
  Form,
  Input,
  InputNumber,
  Modal,
  Select,
  Space,
} from "antd";
import { useState } from "react";

export default function TaskTypeSelectionModal({
  isOpen,
  setIsOpen,
  setIsGroupTaskModalOpen,
}) {
  const [currentSelectedModalTaskType, setCurrentSelectedModalTaskType] =
    useState(null);

  const handleCancel = () => {
    setIsOpen(false);
  };

  const GroupTaskGlobalInputs = ({ taskType }) => {
    if (taskType === "produktionstask1") {
      return (
        <>
          <Divider />
          <h3 style={{ fontWeight: "bold" }}>
            Fill in the global values for the task
          </h3>
          <Form layout="vertical">
            <Form.Item label="Irgendwas tolles" required>
              <Input />
            </Form.Item>
            <Form.Item label="Nummer der Kiste" required>
              <InputNumber defaultValue={0} style={{ width: "100%" }} />
            </Form.Item>
          </Form>
        </>
      );
    } else if (taskType === "printer") {
      return (
        <>
          <Divider />
          <h3 style={{ fontWeight: "bold" }}>
            Fill in the global values for the task
          </h3>
          <Form layout="vertical">
            <Form.Item label="Produktname" required>
              <Input />
            </Form.Item>
          </Form>
        </>
      );
    }

    return <h1>{taskType}</h1>;
  };

  return (
    <Modal
      title="Select a task type"
      open={isOpen}
      onCancel={handleCancel}
      centered
      footer={[
        <Space key={0}>
          <Button key="back" onClick={handleCancel}>
            Cancel
          </Button>

          <Button
            key="submit"
            type="primary"
            disabled={currentSelectedModalTaskType === null}
            onClick={() => {
              setIsOpen(false);
              setIsGroupTaskModalOpen(true);
            }}
          >
            Start task
          </Button>
        </Space>,
      ]}
    >
      <Select
        placeholder="Choose a task"
        style={{ width: "100%" }}
        onChange={(value) => setCurrentSelectedModalTaskType(value)}
      >
        <Select.Option value="acrylglas">
          Acryl Glas gravierung starten
        </Select.Option>
        <Select.Option value="printer">Label drucken</Select.Option>
        <Select.Option value="produktionstask1">
          Produktionstask 1
        </Select.Option>
      </Select>

      <GroupTaskGlobalInputs taskType={currentSelectedModalTaskType} />
    </Modal>
  );
}
